## Sourced from Pybluez rfcomm-server example code
## Modified by Tanmay Chaturvedi
## Contact: Tanmay.Chaturvedi@colorado.edu
## Date: April 25, 2020

from bluetooth import *
import time
import pyautogui
server_sock=BluetoothSocket( RFCOMM )

port = 1
server_sock.bind(("",16))
server_sock.listen(1)

client_sock,address = server_sock.accept()
print ("Accepted connection from "),address

duration = 0.1
pyautogui.moveTo(960,540) # Center of the screen
scaling_factor = 4

#https://stackoverflow.com/questions/822001/python-sockets-buffering
#https://stackoverflow.com/questions/231767/what-does-the-yield-keyword-do
def linesplit(socket):
    result = []
    buffer = socket.recv(1024)
    data = str(buffer).split("'")
    buffer = data[1]
    buffering = True
    while buffering:
        if "\\n" in buffer:
            (line, buffer) = buffer.split("\\n", 1)
            result.append( line + "\\n")
            return(result)
        else:
            more = socket.recv(1024)
            data1 = str(buffer).split("'")
            more = data1[1]
            if not more:
                buffering = False
            else:
                buffer += more
    if buffer:
        result.append(buffer)
    return result
	
try:
    while True:
        data = linesplit(client_sock)
        data = str(data).split("'")
        print("raw split data %s" % data[1])
        new_data = str(data[1]).split()
        button_press = int(new_data[0])
        if button_press == 1:
            #left button press
            pyautogui.click()
        else:
            xval = int(new_data[1])
            yval = int(new_data[2])
            if(abs(xval) > abs(yval)):
                pyautogui.move(0, (-xval/scaling_factor), duration)

            else:
                pyautogui.move((yval/scaling_factor), 0, duration)
		
except IOError:
    pass

print("disconnected")

client_sock.close()
server_sock.close()
print("all done")